<?php
/*
  $Id: abxMessageStack.php,v 1.1 2005/08/02 21:19:25 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  class abxMessageStack
  {
    function add($class, $message, $type = 'error')
    {
      $messageStack = &abxMessageStack::getMessageStack($class);
      $messageStack[] = array('message' => $message, 'type' => $type);
    }

    function add_session($class, $message, $type = 'error')
    {
      $messageStack = isset($_SESSION['abxMessageStack']) ? $_SESSION['abxMessageStack'] : array();

      $messageStack[$class][] = array('msg' => $message, 'type' => $type);

      $_SESSION['abxMessageStack'] = $messageStack;

      abxMessageStack::add($class, $message, $type);
    }

    function reset()
    {
      $messageStack = &abxMessageStack::getMessageStack();
      $messageStack = array();
    }

    function output($class, $output = false, $html_output = true, $seperator = "\n")
    {
      $numberOfMessages = abxMessageStack::size($class);
      if ($numberOfMessages > 0) {
        $messageStack = abxMessageStack::getMessageStack($class);
        $messages = array();
        if ($html_output === true) {
          for($i = 0; $i < $numberOfMessages; $i++) {
            switch($messageStack[$i]['type']) {
              case 'error':
                $bullet_image = DIR_WS_ABX_IMAGES . 'icons/error.gif';
                break;
              case 'warning':
                $bullet_image = DIR_WS_ABX_IMAGES . 'icons/warning.gif';
                break;
              case 'success':
                $bullet_image = DIR_WS_ABX_IMAGES . 'icons/success.gif';
                break;
              default:
                $bullet_image = DIR_WS_ABX_IMAGES . 'icons/bullet_default.gif';
                break;
            }
            $messages[] = '<li style="list-style-image: url(\'' . $bullet_image . '\')">' . htmlspecialchars($messageStack[$i]['message']) . '</li>';
          }
          if ($output === true) {
            echo '<div class="abxMessageStack"><ul>' . implode($seperator, $messages) . '</ul></div>';
          } else {
            return '<div class="abxMessageStack"><ul>' . implode($seperator, $messages) . '</ul></div>';
          }
        } else {
          for($i = 0; $i < $numberOfMessages; $i++) {
            $messages[] = $messageStack[$i]['message'];
          }
          if ($output === true) {
            echo implode($seperator, $messages);
          } else {
            return implode($seperator, $messages);
          }
        }
      }
    }

    function size($class)
    {
      $messageStack = abxMessageStack::getMessageStack();
      return isset($messageStack[$class]) ? count($messageStack[$class]) : 0;
    }

    function &getMessageStack($class = null)
    {
      static $messageStack = array();
      if (is_null($class)) {
        return $messageStack;
      } else {
        return $messageStack[$class];
      }
    }

    function loadFromSession()
    {
      if (isset($_SESSION['abxMessageStack'])) {
        foreach($_SESSION['abxMessageStack'] as $class => $messages) {
          for($i = 0, $n = count($messages); $i < $n; $i++) {
            abxMessageStack::add($class, $messages[$i]['msg'], $messages[$i]['type']);
          }
        }
        unset($_SESSION['abxMessageStack']);
      }
    }
  }//end class
?>